#include "obj02_db_api.h"
#include "obj02_db_dbd.h"

using namespace RDM_CPP;

Db_obj02_db Db_obj02_db::Open (char *mode) throw (rdm_exception&) {
    return Db::Open (Type (), "obj02_db", mode, &obj02_db_dbd, sizeof(obj02_db_dbd));
}

#if !defined(RDM_NO_UNICODE)
Db_obj02_db Db_obj02_db::Open (wchar_t *mode) throw (rdm_exception&) {
    return Db::Open (Type (), L"obj02_db", mode, &obj02_db_dbd, sizeof(obj02_db_dbd));
}
#endif /*RDM_NO_UNICODE*/

Db_obj02_db Db_obj02_db::Open (const char *name, const char *mode) throw (rdm_exception&) {
    return Db::Open (Type (), name, mode, &obj02_db_dbd, sizeof(obj02_db_dbd));
}

#if !defined(RDM_NO_UNICODE)
Db_obj02_db Db_obj02_db::Open (const wchar_t *name, const wchar_t *mode) throw (rdm_exception&) {
    return Db::Open (Type (), name, mode, &obj02_db_dbd, sizeof(obj02_db_dbd));
}
#endif /*RDM_NO_UNICODE*/

dbType Db_obj02_db::Type (void) {
    char static type;
    return &type;
}

Db_obj02_db::Db_obj02_db (void) throw () {
}

Db_obj02_db::Db_obj02_db (const Db& db) throw () : Db (db, Type()) {
}

Db_obj02_db::Db_obj02_db (const Db_obj02_db& db) throw () : Db (db) {
}

Db_obj02_db::Db_obj02_db (IDb *idb) : Db (idb) {
}

Db_obj02_db& Db_obj02_db::operator = (const Db& db) throw (rdm_exception&) {
    AssignAndVerifyType (Type (), db);
    return *this;
}

Db_obj02_db& Db_obj02_db::operator = (const Db_obj02_db& db) throw () {
    *((Db *)this) = db;
    return *this;
}

Db_obj02_db::~Db_obj02_db () {
}

Cursor_obj02 Db_obj02_db::New_obj02_record (void) const throw (rdm_exception&) {
    return Cursor_obj02 (NewRecords (Cursor_obj02::Type ()));
}

Cursor_obj02 Db_obj02_db::New_obj02_recordWithFieldValues (struct obj02 *fields) const throw (rdm_exception&) {
    return Cursor_obj02 (NewRecordsWithFieldValues (Cursor_obj02::Type (), fields));
}

Cursor_obj02 Db_obj02_db::Get_obj02_records (void) const throw (rdm_exception&) {
    return Cursor_obj02 (GetRecords (Cursor_obj02::Type ()));
}

recordType Cursor_obj02::Type (void) {
    return OBJ02;
}

Cursor_obj02::Cursor_obj02 (void) throw () {
}

Cursor_obj02::Cursor_obj02 (const Cursor& cursor) throw (rdm_exception&) : Cursor (cursor, Type ()) {
}

Cursor_obj02::Cursor_obj02 (const Cursor_obj02& cursor) throw () : Cursor (cursor) {
}

Cursor_obj02& Cursor_obj02::operator = (const Cursor& cursor) throw (rdm_exception&) {
    AssignAndVerifyType (Type (), cursor);
    return *this;
}

Cursor_obj02& Cursor_obj02::operator = (const Cursor_obj02& cursor) throw () {
    *((Cursor *)this) = cursor;
    return *this;
}

void Cursor_obj02::SetFieldValues (const struct obj02 *fields) const throw (rdm_exception&) {
    Cursor::SetFieldValues (Type (), fields);
}

void Cursor_obj02::GetFieldValues (struct obj02 *fields) const throw (rdm_exception&) {
    Cursor::GetFieldValues (Type (), fields);
}

void Cursor_obj02::Set_message (const char message_val[32]) const throw (rdm_exception&) {
    SetField (MESSAGE, message_val);
}

void Cursor_obj02::Get_message (char message_val[32]) const throw (rdm_exception&) {
    GetField (MESSAGE, message_val);
}

Cursor_obj02::~Cursor_obj02 () {
}

